Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports['default'] = hypernova;
var LEFT = '<!--';
var RIGHT = '-->';

var ENCODE = [['&', '&amp;'], ['>', '&gt;']];

function encode(obj) {
  return ENCODE.reduce(function (str, coding) {
    var _coding = _slicedToArray(coding, 2);

    var encodeChar = _coding[0];
    var htmlEntity = _coding[1];

    return str.replace(new RegExp(encodeChar, 'g'), htmlEntity);
  }, JSON.stringify(obj));
}

function decode(res) {
  var jsonPayload = ENCODE.reverse().reduce(function (str, coding) {
    var _coding2 = _slicedToArray(coding, 2);

    var encodeChar = _coding2[0];
    var htmlEntity = _coding2[1];

    return str.replace(new RegExp(htmlEntity, 'g'), encodeChar);
  }, res);

  return JSON.parse(jsonPayload);
}

function backwardCompat(node, attr, key) {
  return String(node) + '[data-mystique-key="' + String(key) + '"],' + String(node) + '[data-' + String(attr) + '="' + String(key) + '"]';
}

function toScript(attr, key, props) {
  return '<script type="application/json" data-' + String(attr) + '="' + String(key) + '">' + LEFT + String(encode(props)) + RIGHT + '</script>'; // eslint-disable-line max-len
}

function fromScript(attr, key) {
  var node = document.querySelector(backwardCompat('script', attr, key));
  if (!node) return null;
  var jsonPayload = node.innerHTML;
  return decode(jsonPayload.slice(LEFT.length, jsonPayload.length - RIGHT.length));
}

function serialize(name, html, data) {
  var key = name.replace(/\W/g, '');
  var markup = '<div data-hypernova-key="' + String(key) + '">' + String(html) + '</div>';
  var script = toScript('hypernova-key', key, data);
  return markup + '\n' + String(script);
}

function load(name) {
  var key = name.replace(/\W/g, '');
  var node = document.querySelector(backwardCompat('div', 'hypernova-key', key));
  if (!node) return {};

  var data = fromScript('hypernova-key', key);
  return { node: node, data: data };
}

function hypernova(runner) {
  return typeof window === 'undefined' ? runner.server() : runner.client();
}

hypernova.toScript = toScript;
hypernova.fromScript = fromScript;
hypernova.serialize = serialize;
hypernova.load = load;
module.exports = exports['default'];